package de.unisb.prog.typestate;

import java.util.ArrayList;
import java.util.List;

import de.unisb.prog.typestate.dummyImpl.File;
import de.unisb.prog.typestate.dummyImpl.Obj;
import de.unisb.prog.typestate.dummyImpl.Stack;

@SuppressWarnings("unused")
public class TestClass {

	private String	host;
	private int		port;
	private String	username;
	private char[]	password;

	private File	field;
	private File	field2;

	public void breaktest() {
		boolean b = false;
		File file = new File();
		while (b) {
			file.open();
			if (b)
				break;
			file.close();
			
		}
			
	}
	
	public void img_dyntype() {
		List<Object> l = getList();
		l.add(this);
	}
	
	
	private List<Object> getList() {
		return new ArrayList<Object>();
	}

	public void img_call() {
		File f = new File();
		Stack s = new Stack();
		m_init(s);
		s.push(f.read());
	}
	
	public void img_split() {
		boolean b = false;
		File f;
		if (b)
			f = new File();
		else
			f = new File();
		f.open();
		
			
	}
	public void throwTest() throws Exception{
		File f = new File();
		f.open();
		throw new Exception();
	}
	
	public boolean throwCatchTest() {
		File f = new File();
		try {
			throwTest();
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	
	public void fieldInterprocTest() {
		File file = new File();
		field = file;
		// File a = field;
		// a.open();
		// field.read();
		// file.close();
		// field.open();
		// file.read();
		// field = new File();
		// a.close();
		// field.open();
		file.open();
		// a.read();
		// field.close();
		// boolean b = false;
		// File a = new File();
		//		
		// field = a;
		// // field = new File();
		// // File b = field;
		// // field = new File();
		// // File c = field;
		fieldInterprocTestHelper();
		// a.read();
		field.read();

	}

	private File fieldInterprocTestHelper() {
		TestClass tc = new TestClass();
		boolean b = false;
		if (b)
			tc = this;
		tc.field = new File();
		// File z = new File();
		// field = z;
		// z = field;
		// z.open();
		tc.field.open();
		// field.read();
		// field = new File();
		field.open();
		return tc.field;

	}

	public void loopptsto() {
		File a = new File();
		boolean b = false;
		if (b)
			a = new File();
		a.open();

	}
	
	@SuppressWarnings("null")
	public void nullTest() {
		File f = new File();
		f.open();
		Obj obj = f.read();
		boolean b = false;
		if (b)
			obj = new Obj();
		obj.toString();
		f.close();
		
		File g = null;
		g.isOpen();
		
		g = new File();
		if (b)
			g = null;
		g.open();
	}

	public void newTest() {
		boolean b = false;
		File f = new File();
		f.open();
		while (b) {
			f = new File();
		}
	}

	public void bla2323(boolean condition) {
		// Object o,u,v,w;
		// o = new Object();
		// u = o;
		// v = u;
		// w = v;
		// w.equals(v);

		// Object o,u,v,w;
		// o = new Object();
		// u = o;
		// v = u;
		// w = v;
		// v = new Object();
		// w.equals(v);

		java.io.File f = new java.io.File("hello");
		if (condition) {
			f = new java.io.File("world");
		}
		f.delete();
	}

	public void main() {

		File f = new File();
		Stack s = new Stack();

		// memberField = f;
		// TypestateHelper.state_print(memberField, "State of field after assignment");
		// TypestateHelper.state_print(f, "State of f prior to open");
		// f.open();
		// TypestateHelper.state_print(f, "State of f after open");
		// TypestateHelper.state_print(memberField, "State of field after open");
		// memberField.open();
		// TypestateHelper.state_print(memberField, "State of field after calling open on field");
		m_init(s);
		// inited == wrote stack to file
		boolean inited = s.isEmpty();

		if (!inited) {
			// TypestateHelper.state_ignore(s, "isEmpty");
			f.write(s);
		}

		// do some work
		s.push(f.read());
		// TypestateHelper.state_print(s, "State of s before copy");
		Stack copy = m_copyStack(s);
		// TypestateHelper.state_print(s, "State of s after copy");
		// TypestateHelper.state_print(copy, "State of copy after copy");
		copy.pop();
		copy.push(new Obj());

		// make a mistake
		copy.push(s.pop());
		// main();
	}

	private void m_init(Stack s) {
		s.push(new Obj());
//		f.open();

//		boolean someCond = false;
//		if (someCond) {
//			f.write(s);
//		}

	}

	private Stack m_copyStack(Stack source) {
		Stack copy = new Stack();
		while (!source.isEmpty()) {
			TypestateHelper.state_ignore(source, "isEmpty");
			copy.push(source.pop());
		}
		TypestateHelper.state_set(source, "isEmpty");
		return copy;
	}

	public void bla() {
		File a = new File();
		File b = new File();
		File c = new File();

		boolean bo = false;
		while (bo) {
			a.open();
			a = b;
			b = c;
			c = new File();
		}

		a.close();
		b.open();
		c.open();
	}

	public void bla2(File[] arr) {
		// boolean b = false;
		File b = new File();
		memberField = new File();
		File a = memberField;

		memberField2 = b;
		// memberField2 = memberField;
		// if (b) {
		// File c = new File();
		// memberField = c;
		// }
		File c = memberField2;
		memberField.open();
		a.open();
		//
		c.open();
		b.open();
		arr[1].open();
		int i[] = new int[01];
		i[1] = i[1];
	}

	public void bla3() {
		File a = new File();
		File b = new File();

		b.open();
		while (a == b) {
			a.open();
			a.close();
			a = b;
		}

	}

	private int			intField;
	private File		memberField, memberField2;
	public static File	staticField;

	public TestClass() {
		Integer i = 2;
		i.byteValue();

	}

	public File t_recursionTest(File p1) {
		p1.open();
		return t_recursionTest(p1);
	}

	public File fieldTest() {
		File p1 = new File();
		File p2 = new File();
		boolean b = false;
		p1.open();
		memberField = p1;
		if (b) {
			memberField = p2;
			memberField.close();
			// staticField = memberField;
		}
		memberField.open();
		return memberField;

	}

	public void validFileTest(File f, File g) {
		f.open();
		g.open();
		f.read();
		f.read();
		f.close();
		g.read();
		g.close();
	}

	public File[] arrayTest(int i, File[] farr, int j) {
		return farr;
	}

	public void bigTest() {
		boolean bool = false;
		File f = new File();
		File a = f;
		File b = new File();
		File c = new File();

		arrayTest(3, null, 5);

		// do {
		// a.open();
		// a = b;
		// b = c;
		// c = new File();
		// } while (bool);
		// f.close();
		// a.close();
		// b.open();
		// c.open();
		// File j = new File();
		//
		// boolean b = false;
		// File g = j;
		// g = i;
		// if (b) {
		// g.open();
		// } else {
		// g.open();
		// // i.open();
		// g.read();
		// // g.close();
		// }
		// g.read();

		// File ifield = memberField;
		// memberField = j;
		// j.open();
		// ifield.open();
		// memberField.open();
		// i.close();
		// memberField.read();
		// i.open();
		//		
		// boolean b = false;
		// if (b)
		// i.open();
		// i.read();
		//		

		// while (b) {
		// if (b) {
		// i = j;
		// } else
		// j = i;
		//
		// i.open();
		// }
	}

	public File call_retArg(File f) {
		f.open();
		return f;
	}

	public File call_retSingle() {
		File f = new File();
		f.open();
		return f;
	}

	public File call_retAmbig() {
		File f = new File();
		boolean b = false;
		if (b) {
			f.open();
			return f;
		} else {
			f = new File();
			return f;
		}
	}

	public File call_retSingleField() {
		File f = new File();
		f.open();
		memberField = f;
		return memberField;
	}

	public File call_retAmbigField() {
		File f = new File();
		f.open();
		memberField = f;
		memberField = new File();
		return memberField;
	}

	public void loopTest() {
		boolean b = false;
		File f = new File();
		while (b)
		{
			f.open();
			if(b) {
				break;
			}
			f.close();
		}
		f.open();
		if (b) {
			f.close();
			while (b) {
				f.open();
			}
		}
		
		f.read();
		f.close();
	}

	// File file = new File();
	// Stack stack = new Stack();
	// if (!opened) {
	// file.open();
	// stack.push();
	// }
	// while (opened)
	// file.read();
	//
	// stack.pop();
	// int i = 0;
	// while (i < 3) {
	// file.read();
	// stack.push();
	// }
	// if (!stack.isEmpty()) {
	// stack.push();
	// stack.pop();
	// }
	// file.close();
	// }

	public void mergeTest() {
		boolean opened = false;
		File file = new File();
		if (!opened) {
			file.open();
			file.read();
		}
		file.read();
		file.close();
	}

	public void stackTest() {
		Stack stack = new Stack();
		stack.push(null);
		stack.push(null);
		stack.pop();
		if (!stack.isEmpty()) {
			TypestateHelper.state_ignore(stack, "isEmpty");
			stack.pop();
		} else {
			TypestateHelper.state_ignore(stack, "!isEmpty");
			stack.push(null);
			stack.pop();
		}
	}

	public void fuzzyTest() {
		// File dummy = new File();
		// Stack stack = new Stack();
		// File f = new File();
		// File g = new File();
		// dummy.recursion_two(f, stack, g);
		// f.open();
		// f.write(stack);
		// f.close();

		File f = new File();
		File g = new File();
		File dummy = new File();
		// int[] a = new int[1];
		// int b = a[1];
		intField = 0;

		// File dummy = new File();
		// File f = new File();
		// File g = new File();
		// dummy.recursion_two(f, g);
		// dummy.recursion_two(f, g);
	}

	public void failingFileTest(File f, File g) {
		f.open();
		g.read();
		g.open();
		f.close();
		f.read();
	}

//	public void hugeTest(File f, File g) {
//		boolean b = false;
//		while (b) {
//			while (b) {
//				while (b) {
//					while (b) {
//						while (b) {
//
//							f.open();
//							g.open();
//							f.read();
//							f.read();
//							f.close();
//							g.read();
//
//							g.close();
//							while (b) {
//								f.open();
//								g.open();
//								f.read();
//								f.read();
//								f.close();
//								g.read();
//
//								g.close();
//								while (b) {
//									f.open();
//									g.open();
//									f.read();
//									f.read();
//									f.close();
//
//									g.read();
//									g.close();
//									while (b) {
//										f.open();
//										g.open();
//										f.read();
//										f.read();
//										f.close();
//
//										g.read();
//										g.close();
//									}
//								}
//							}
//						}
//						f.open();
//						g.open();
//						f.read();
//						f.read();
//
//						f.close();
//						g.read();
//						g.close();
//					}
//					while (b) {
//
//						f.open();
//						g.open();
//						f.read();
//						f.read();
//						f.close();
//						g.read();
//
//						g.close();
//						while (b) {
//							f.open();
//							g.open();
//							f.read();
//							f.read();
//							f.close();
//							g.read();
//
//							g.close();
//							while (b) {
//								f.open();
//								g.open();
//								f.read();
//								f.read();
//								f.close();
//
//								g.read();
//								g.close();
//								while (b) {
//									f.open();
//									g.open();
//									f.read();
//									f.read();
//									f.close();
//
//									g.read();
//									g.close();
//								}
//							}
//						}
//					}
//					f.open();
//					g.open();
//
//					f.read();
//					f.read();
//
//					f.close();
//					g.read();
//					g.close();
//				}
//				while (b) {
//
//					f.open();
//					g.open();
//					f.read();
//					f.read();
//					f.close();
//					g.read();
//
//					g.close();
//					while (b) {
//						f.open();
//						g.open();
//						f.read();
//						f.read();
//						f.close();
//						g.read();
//
//						g.close();
//						while (b) {
//							f.open();
//							g.open();
//							f.read();
//							f.read();
//							f.close();
//
//							g.read();
//							g.close();
//							while (b) {
//								f.open();
//								g.open();
//								f.read();
//								f.read();
//								f.close();
//
//								g.read();
//								g.close();
//							}
//						}
//					}
//				}
//				f.open();
//				g.open();
//
//				f.read();
//				f.read();
//
//				f.close();
//				g.read();
//				g.close();
//			}
//			while (b) {
//				while (b) {
//
//					f.open();
//					g.open();
//					f.read();
//					f.read();
//					f.close();
//					g.read();
//
//					g.close();
//					while (b) {
//						f.open();
//						g.open();
//						f.read();
//						f.read();
//						f.close();
//						g.read();
//
//						g.close();
//						while (b) {
//							f.open();
//							g.open();
//							f.read();
//							f.read();
//							f.close();
//
//							g.read();
//							g.close();
//							while (b) {
//								while (b) {
//									while (b) {
//
//										f.open();
//										g.open();
//										f.read();
//										f.read();
//										f.close();
//										g.read();
//
//										g.close();
//										while (b) {
//											f.open();
//											g.open();
//											f.read();
//											f.read();
//											f.close();
//											g.read();
//
//											g.close();
//											while (b) {
//												f.open();
//												g.open();
//												f.read();
//												f.read();
//												f.close();
//
//												g.read();
//												g.close();
//												while (b) {
//													f.open();
//													g.open();
//													f.read();
//													f.read();
//													f.close();
//
//													g.read();
//													g.close();
//												}
//											}
//										}
//									}
//									f.open();
//									g.open();
//
//									f.read();
//									f.read();
//
//									f.close();
//									g.read();
//									g.close();
//								}
//								f.open();
//								g.open();
//								f.read();
//								f.read();
//								f.close();
//
//								g.read();
//								g.close();
//							}
//						}
//					}
//				}
//				f.open();
//				g.open();
//
//				f.read();
//				f.read();
//
//				f.close();
//				g.read();
//				g.close();
//			}
//			while (b) {
//
//				f.open();
//				g.open();
//				f.read();
//				f.read();
//				f.close();
//				g.read();
//
//				g.close();
//				while (b) {
//					f.open();
//					g.open();
//					f.read();
//					f.read();
//					f.close();
//					g.read();
//
//					g.close();
//					while (b) {
//						f.open();
//						g.open();
//						f.read();
//						f.read();
//						f.close();
//
//						g.read();
//						g.close();
//						while (b) {
//							f.open();
//							g.open();
//							f.read();
//							f.read();
//							f.close();
//
//							g.read();
//							g.close();
//						}
//					}
//				}
//			}
//			f.open();
//			g.open();
//
//			f.read();
//			f.read();
//
//			f.close();
//			g.read();
//			g.close();
//		}
//	}
}
