package de.unisb.prog.typestate;

import java.util.Set;

public class Transition implements ITransition {

	private String					source;
	private String					dest;
	private Set<IMethodIdentifier>	label;

	public Transition(String source, String dest, Set<IMethodIdentifier> label) {
		this.source = source;
		this.dest = dest;
		this.label = label;
	}

	public String getDestinationName() {
		return dest;
	}

	public Set<IMethodIdentifier> getMarking() {
		return label;
	}

	public String getSourceName() {
		return source;
	}

}
