package de.unisb.prog.typestate.ir;

import java.util.Iterator;

import de.unisb.prog.analysis.ContextAndNode;
import de.unisb.prog.pointsto.HashPointsToSet;

public class ModifiablePointsToSet extends HashPointsToSet {

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.unisb.prog.pointsto.PointsToSet#remove(java.lang.Object)
	 */
	@Override
	public boolean remove(Object o) {
		for (Iterator<ContextAndNode> it = iterator(); it.hasNext();) {
			if (o == null ? it.next() == null : it.next().equals(o)) {
				it.remove();
				return true;
			}
		}
		return false;
	}

}
