package de.unisb.prog.typestate.ir;

import de.unisb.prog.jfirm.ir.Block;
import de.unisb.prog.jfirm.ir.Node;
import de.unisb.prog.jfirm.ir.NodeVisitor;
import de.unisb.prog.jfirm.ir.ValueNode;

public class InfoNodeVisitor implements NodeVisitor {

	public void init(int range) {

	}

	public void post(Node node) {
		if (node instanceof Block) {
			Block b = (Block) node;
			System.out.println("Visiting Block: " + b);
//			System.out.println("\tJump: " + b.jump());
		} else if ( node instanceof ValueNode) {
			ValueNode v = (ValueNode) node;
			System.out.println("Visiting Node: " + v);
			System.out.println("\tin Block: " + v.getBlock());
			System.out.println("\tMode: " + v.getMode());
			System.out.println("\tOpcode: " + v.getOpcode());
			System.out.println("\tProducer: " + v.getProducer());
		} else {
			System.out.println("UNKNOWN NODE TYPE!! " + node);
		}
		
		
	}

	public void pre(Node node) {

	}

}
