package de.unisb.prog.typestate.ir.oldstuff;

import java.util.Set;

import de.unisb.prog.typestate.ir.AllocSite;

public interface IAliasInfo {

	/**
	 * Returns all aliases found for the given allocation site.
	 * @param forSite the site for which aliases are to be returned
	 * @return the set of (potentially) aliasing allocation sites
	 */
	public Set<AllocSite> getAliases(AllocSite forSite);
	
}
