package de.unisb.prog.typestate.ir.oldstuff;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;

@SuppressWarnings("unused")
public class TalkClass {

	public void wakeUp(String address) throws IOException {

		// Create socket for sending the message
		Socket socket = new Socket();
		byte[] wakeupMessage;

		/*
		 * Very (VERY!) complex routines to build the wake up message
		 */
		wakeupMessage = "wake up!".getBytes();
		/*
		 * Finished building wake up message
		 */

		// Now send the message
		socket.connect(new InetSocketAddress(address,80));
		OutputStream os = socket.getOutputStream();
		os.write(wakeupMessage);
	}

	public byte readSimple(File file) throws FileNotFoundException, IOException {
		return (byte) new FileInputStream(file).read();
	}
	
	public byte readUgly(File file) throws FileNotFoundException, IOException {
		File theFile = file;
		InputStream fStream = new FileInputStream(theFile);
		byte returnChar = (byte) fStream.read();
		return returnChar;
	}
	
	public static void main(String[] args) {
		try {
			new TalkClass().wakeUp("127.0.0.1");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void bla(File f) {
		@IgnoreState("CLOSED") File g = f;
		
		
	}
	
	
}
