package de.unisb.prog.typestate.violation;

public interface ISuggestion {

	public enum SuggestionType {
		STATE_EXCLUSION, ALTERNATE_METHODS
	}
	
	/**
	 * @return the {@link SuggestionType} of the ISuggestion
	 */
	public SuggestionType getType();
	
	/**
	 * @return a textual representation of the suggestion
	 */
	public String text();
	
	/**
	 * TODO
	 * @return the callVioInfo
	 */
	public Object getSuggestions();
}
